<?php
/*
Plugin name: Cosmic BP User Signup Password
Author:Brajesh Singh
Author URI:http://ThinkingInWordpress.com
Plugin URi:http://www.thinkinginwordpress.com/2009/07/allow-users-to-set-their-own-password-at-buddypress-registration-page/
Version:1.0
Tags:buddypress,wpmu,bp,user password,password,signup,enhancement,register
*/
/***
note :cc stands for cosmic coders*/
/**********Let us hook into the system ***/
add_action("signup_extra_fields","cc_bp_pass_show_password_form",1,0);//hook password form at signup page
add_action("signup_hidden_fields","cc_bp_pass_add_to_hidden_fields");//we need it incase of blog regitration+user registration is enabled,save the pswword at 2nd step of registration
add_filter("add_signup_meta","cc_bp_pass_add_pass_to_blog_meta",100,1);//store the password into the signup meta field
add_filter("random_password","cc_bp_pass_return_my_password"); //return users choosen password at activation

/*** 
wpr_bp_pass_show_password_form()

we are simply inserting the password field as an extra field in the buddypress signup form */

function cc_bp_pass_show_password_form()
{
?>
<div id="password-form-field">
	<h3><?php _e( 'Enter your password', 'buddypress' ); ?></h3>
	<p class='password-help-text'><?php _e( 'Choose a password which suits your memory ! If you don\'t choose one,We will generate a random Password', 'buddypress' ); ?>
	</p>
	<div class='password-field'>
		<input type='password' name='user_password' id='user_password'/>
	</div>
</div>
<?php	


}

/*
wpr_bp_pass_add_to_hidden_fields()

It is used in case the user and blog creation both are allowed,we store the password as clear text(sigh!) in the hidden field at the second step of registration 
*If you can think of some better way of storing the password at secons stpe,please let me know, It is most appreciated 
*/

function cc_bp_pass_add_to_hidden_fields()
{
?>
	<input type="hidden" name="user_password" value="<?php echo $_POST['user_password']; ?>" />
<?php 

}
/*
wpr_bp_pass_add_pass_to_blog_meta()
At signup,we must store the password somewhere,I am storing in the signup meta field
*/

function cc_bp_pass_add_pass_to_blog_meta($meta){

	$password=$_POST['user_password'];//get the user password
	$meta["user_password"]=$password; //just appended the password to meta array

	return $meta;
}

///for activation//generating random password
function cc_bp_pass_return_my_password($password){
//let us process meta
	global $wpdb;
	$key = !empty($_GET['key']) ? $_GET['key'] : $_POST['key'];
	if(empty($key)) /** is it not the activation step,do not do any thing, just return the generated password */
		return $password;

/** if we are here,It means we are at activation stage */
	/*let us fetch the meta */
	$signup = $wpdb->get_row( $wpdb->prepare("SELECT * FROM $wpdb->signups WHERE activation_key = %s", $key) );
	$meta = unserialize($signup->meta);//unserialize the meta
	$pass=$meta["user_password"]; //get the password
	//should we do the cleanup of meta /database for security reasons,no more clear text password
	$meta["user_password"]="";//remove the password from meta
	$normalized_meta=serialize($meta);//let us serialize the updated meta
	//update signup table with the new meta-just cleaning up
	$wpdb->query($wpdb->prepare("UPDATE $wpdb->signups SET meta='".$normalized_meta."' WHERE activation_key = %s", $key));
//we are done now

	if(empty($pass)) /**if password it empty,return the random password generated by the system */
		return $password;
	else
		return $pass; /**else return user's password ,which he/she entered at registration*/
}
?>